function ChromeExtension() {

    var listenners = [];

    this.sendMessage = function(obj, __callback) {

        console.log("##sendMessage## for " + obj.method);

        listenners.forEach(function(l) {

            l(obj, null, function(r) {

                if (__callback != null) {
                    console.log("##sendResponse## from " + obj.method);
                    __callback(r);
                }

            });

        });

    }

    this.onMessage = {
        addListener: function(callback) {

            //function(request, sender, sendResponse) 

            listenners.push(callback);


        }
    }

    return this;
}

function ChromeI18n() {

    var i18n = null;
    self.port.on("onGetLocale", function(obj) {
        i18n = obj;
    });
    self.port.emit("onGetLocale");

    this.getMessage = function(id) {
        if (i18n == null) return id;
        return i18n[id].message;
    }
    this.getUILanguage = function() {
        return "en";
    }
    return this;
}

function Chrome() {

    this.i18n = new ChromeI18n();
    this.runtime = new ChromeExtension();

    this.tabs = {
        onUpdated: {
            addListener: function(callback) {

            }
        },
        getSelected: function(obj, callback) {
            callback({
                id: 0
            });
        },
        sendMessage: function(id, message) {

            chrome.runtime.sendMessage(message);
        }
    };

    this.browserAction = {
        setIcon: function(obj) {

            self.port.emit("onSetIcon", obj);

        }
    };

    return this;

}

console.log("============= CHROME! =================");
var chrome = new Chrome();

/* ======================================================= */

function AqiStore() {

    var ls = [];

    this.get = function(a) {

        return ls[a];
    }

    this.set = function(a, v) {

        ls[a] = v;

        self.port.emit("syncstorage", {
            name: a,
            val: JSON.stringify(v)
        });
    }

    self.port.on("syncstorage", function(obj) {
        obj = JSON.parse(obj);
        if (obj) ls = obj;
    });

    return this;
}

var store = new AqiStore();

/* ======================================================= */

function JSONContentScriptLoader(self) {

    var idx = 0;
    var callbacks = [];
    var ongoing = 0;

    this.load = function(url, callback, opts) {

        opts = opts || {
            type: 'json'
        };
        callbacks[idx] = callback;
        ongoing++;

        self.port.emit('loadJSON', {
            url: url,
            id: idx++,
            type: opts.type
        });

        console.log("Loading (CS) " + url + " -> " + idx);
    };

    self.port.on("onJsonLoaded", function(obj) {

        console.log("onJsonLoaded! " + obj.obj.id);

        ongoing--;
        var cb = callbacks[obj.obj.id];
        if (ongoing == 0) callbacks = [];
        if (obj.obj.type == 'json') {
            cb(eval("(" + obj.data + ")"));
        } else {
            cb(obj.data);
        }

    });
    return this;
}

function JSONDirectLoader() {

    this.load = function(url, callback) {

        var xhttp = null;
        if (window.XMLHttpRequest) {
            xhttp = new XMLHttpRequest();
        } else {
            xhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        xhttp.open("GET", url);

        xhttp.onload = function() {
            var json = eval("(" + xhttp.response + ")");
            callback(json);
        }
        xhttp.onerror = function() {
            console.log("XMLHttpRequest error! " + xhttp.statusText);
            callback(null);
        }
        xhttp.onreadystatechange = function() {
            if (xhttp.readyState != 4) {
                return;
            }
            if (xhttp.status != 200) {
                console.log("XMLHttpRequest http status " + xhttp.status);
                return;
            }
            var serverResponse = xhttp.responseText;
        };
        xhttp.send();

    };

    return this;
}


var xJSON = null;
if (self.port) {
    console.log("using contnent script loader");
    xJSON = new JSONContentScriptLoader(self);
} else {
    console.log("using direct loader");
    xJSON = new JSONDirectLoader();
}

/* ======================================================= */

self.port.on("preferences", function(obj) {

    var preferences = JSON.parse(obj);
    console.log(preferences);
    background.setPref(preferences);

});


/* ======================================================= */

self.port.on("onOpenPanel", function(obj) {
    citySearchInit();
});

self.port.on("onReady", function(obj) {
    try {
        startBackground();
    } catch (e) {}
    try {
        startGoogle();
    } catch (e) {}
});