function CitySearch() {

    this.clearResultsTimer = null;

    var url = function() {
        var t = new Date().getTime();
        //return "http://localhost/viewjp2/mapi/?lang=en&key&n=28&term=";
        return "http://waqi.aqicn.org/mapi/?lang=en&key&n=28&t=" + t + "&term=";
    };


    var formatData = function(data, eltID) {
        var cityurl = "http://aqicn.org/?city=";

        var c = "<table class='citysearch'>";
        for (var i = 0; i < data.length; i++) {
            var item = data[i];
            var url = cityurl + item.id;

            if (typeof item.curl != "undefined") {
                url = item.curl;
                url += "m/";
            }

            var utime = "";
            try {
                moment(item.utime * 1000).format("ddd, hA");
            } catch (e) {}

            var bgcol = aqiUtils.bgcolor(item.aqi);
            var fgcol = aqiUtils.fgcolor(item.aqi);
            var aqiv = item.aqi;

            var cla = (i != data.length - 1) ? "marker" : "";

            c += "<tr class='" + cla + "' id='cityitem" + i + "' >";
            c += "<td class='cityentryname'>" + item.name + "<small> " + utime + "</small>" + "</span>";
            c += "<td><span class='cityentryaqitag' style='background-color:" + bgcol + ";color:" + fgcol + "'>" + aqiv + "</span>";
        };
        if (data.length == 0) {
            c += "<tr><td class='cityentryname'>" + chrome.i18n.getMessage("search_no_result") + "</td></tr>";
        }
        c += "</table>";

        $("#" + eltID).html(c).show();

        var setl = function(idx) {
            document.getElementById("cityitem" + idx).onclick = function() {
                onClick(idx);
            }
        }
        for (var i = 0; i < data.length; i++) setl(i);
    }

    var onWidgetLoaded = function(data, lang) {
        console.log("Widget loaded!");
        $("#cityaqiwidget").html(data.xxl).show();
        $("#selectedcity").html("");

        var aqi = $("#aqiwgtmsg").html();
        var txt = aqiLang.getAqiText(aqi, lang);
        $("#aqiwgtmsg").html(txt);
    }

    var loadWidget = function() {

        console.log("loadWidget");

        aqiSettings.cityObject(function(obj) {

            console.log(obj);
            if (obj.key == null) {
                console.log("city key is null!!");
                return;
            };

            var t = new Date().getTime();
            var url = "http://aqicn.org/aqicn/cache/webwgt/" + obj.key + "/widget.v1.js?" + t;
            //var url = "http://localhost/viewjp2/aqicn/cache/webwgt/" + o.key + "/widget.v1.js";
            console.log("Loading " + url);

            xJSON.load(url, function(data) {
                console.log("Loaded!");
                if (data == null) {
                    $("#cityaqiwidget").html(chrome.i18n.getMessage("search_load_error")).show();
                } else {
                    data = data.substring("aqicnWidgetLoaderCallback(".length);
                    data = data.substring(0, data.indexOf(");"));
                    data = $.parseJSON(data);
                    onWidgetLoaded(data, obj.clang);
                }
            }, {
                type: 'raw'
            });

        });
    }

    var init = function() {

        $("#searchresults").hide();
        $("#cityaqiwidget").hide();

        $("#loading").hide();
        $("#loadingtext").html(chrome.i18n.getMessage("loading"));

        aqiSettings.cityObject(function(obj) {
            if (obj) {
                $("#selectedcitytitle").html(obj.name);
                $("#selectedcity").html(chrome.i18n.getMessage("search_selected_city") + " <b> " + obj.name);
                $("#cityinput").attr("placeholder", chrome.i18n.getMessage("search_select_another"));
                loadWidget();
            } else {
                $("#cityinput").attr("placeholder", chrome.i18n.getMessage("search_enter_city"));
                $("#selectedcity").html("");
            }
        });

        document.getElementById("cityinput").onkeyup = function() {
            onKeyUp();
        }

    }

    var onClick = function(idx) {
        var o = this.data[idx];

        aqiSettings.setCityObject(o);
        $("#selectedcitytitle").html(o.name);
        $("#selectedcity").html(chrome.i18n.getMessage("search_selected_city") + " <b>" + o.name);
        loadWidget();

        if (this.clearResultsTimer) {
            clearTimeout(this.clearResultsTimer);
        }
        this.clearResultsTimer = setTimeout(function() {
            $("#searchresults").slideUp(200);
            $("#cityinput").val("");
        }, 1000);
    }

    var onKeyUp = function() {
        if (this.clearResultsTimer) {
            clearTimeout(this.clearResultsTimer);
        }
        var value = document.getElementById('cityinput').value;
        if (value == '' || value == null) {
            $("#loading").hide();
            $("#cityaqiwidget").show();
            return;
        }
        var _url = url() + value;
        console.log("xLoading " + _url);

        $("#loading").show();
        $("#cityaqiwidget").hide();
        loadWidget
        xJSON.load(_url, function(d) {
            onSearchCallback(d);
        });
    };

    var onSearchCallback = function(data) {
        $("#loading").hide();
        document.getElementById("cityinput").className = "";
        this.data = data;
        formatData(data, "searchresults");

    }

    var aqiSettings = new AqiSettings();
    init();

    this.restart = function() {
        init();
    }

    return this;
}

var citySearch = null;

function citySearchInit() {
    if (citySearch == null)
        citySearch = new CitySearch();
    else citySearch.restart();
}