function save_options() {

    var opts = ["baidu", "bing", "google"];
    for (opt in opts) {
        opt = opts[opt];
        var c = document.getElementById(opt).checked;
        console.log(c);
        localStorage["optchecked" + opt] = c;
    }


    var en = document.getElementById("langen");
    var cn = document.getElementById("langcn");
    console.log(en.checked);
    if (en.checked == true) {
        console.log("EN");
        cn.checked = false;
    } else {
        console.log("CN");
        cn.checked = true;
        en.checked = false;
    }
    console.log("CN:" + cn.checked);
    console.log("EN:" + en.checked);

    // Update status to let user know options were saved.
    var status = document.getElementById("status");
    status.innerHTML = "Options Saved.";
    setTimeout(function() {
        status.innerHTML = "";
    }, 750);

    chrome.runtime.sendMessage({
        method: 'saveOptions',
        options: localStorage
    }, function(response) {
        console.log(response);
    });
}

// Restores select box state to saved value from localStorage.
function restore_options() {


    var opts = ["baidu", "bing", "google"];
    for (var opt in opts) {
        opt = opts[opt];
        var checked = localStorage["optchecked" + opt];
        if (typeof checked == "undefined") checked = "true";
        var o = document.getElementById(opt);
        if (!o) continue;
        if (checked == "true") {
            o.checked = true;
        } else {
            o.checked = false;
        }

        o.onclick = function() {
            save_options();
        }
    }

}


function LangSelector() {

    var langs = ["cn", "en", "hk", "jp", "kr"];

    var onClick = function(lang) {

        console.log("SetLang(" + lang + ")");
        for (l in langs) {
            var opt = "lang" + langs[l];
            var o = document.getElementById(opt);
            if (!o) continue;
            if (lang == langs[l]) {
                o.checked = true;
            } else {
                o.checked = false;
            }
        }

        localStorage["xlang"] = lang;

        chrome.runtime.sendMessage({
            method: 'setLang',
            lang: lang
        }, function(response) {

        });
    }

    var init = function() {
        function setClicker(l) {
            var o = document.getElementById("lang" + l);
            if (o) o.onclick = function() {
                onClick(l);
            }

        }
        if (typeof localStorage["xlang"] == undefined ||
            localStorage["xlang"] == "false" ||
            localStorage["xlang"] == null) {
            localStorage["xlang"] = "en";
        }
        console.log("lang=" + localStorage["xlang"]);

        for (var l in langs) {
            l = langs[l];
            var checked = localStorage["xlang"] == l;
            var o = document.getElementById("lang" + l);
            if (o) o.checked = checked;
            setClicker(l);
        }
    }

    init();
    return this;

}


document.addEventListener('DOMContentLoaded', function() {
    new LangSelector();
    restore_options();


    $(".i18n").each(function(d) {
        var id = $(this).attr("id");
        var val = chrome.i18n.getMessage(id);
        console.log("Localizing " + id + " -> " + val);
        $("#" + id).html(val);
    })


    var aqiSettings = new AqiSettings();

    aqiSettings.setOnAqiUpdate(function(aqi) {
        /* Refresh the extra info */
        console.log(aqi);
        var txt = aqiUtils.getAqiBadge(aqi) + " - " + aqi.weather;
        //txt += aqiUtils.getgraph(aqi);
        $("#selectedcityextrainfo").html(txt);

    });

})